
Ruby - Bug #18878

parse.y: Foo::Bar {} is inconsistently rejected

06/26/2022 01:06 PM - qnighy (Masaki Hara)

Status: Assigned   

Priority: Normal   

Assignee: ydah (Yudai Takada)   

Target version:    

ruby -v: ruby 3.1.2p20 (2022-04-12 revision

4491bb740a) [x86_64-linux]

Backport: 2.7: UNKNOWN, 3.0: UNKNOWN, 3.1:

UNKNOWN

Description

The following source doesn't parse:

Foo::Bar {}

 despite the following:

bar           # local variable or method call

Bar           # constant

bar()         # method call

Bar()         # method call

bar {}        # method call

Bar {}        # method call

bar() {}      # method call

Bar() {}      # method call

Foo::bar      # method call

Foo::Bar      # constant

Foo::bar()    # method call

Foo::Bar()    # method call

Foo::bar {}   # method call

# Foo::Bar {} # SyntaxError

Foo::bar() {} # method call

Foo::Bar() {} # method call

 Especially considering Bar {}, this looks like a missing implementation rather than an intentional behavior.

History

#1 - 06/27/2022 04:48 PM - lhmzhou (Linda Zhou)

Is there a more descriptive error message, or is SyntaxError the only output provided?

#2 - 06/28/2022 03:38 AM - qnighy (Masaki Hara)

Is there a more descriptive error message, or is SyntaxError the only output provided?

 This is the actual error message:

% ruby -e 'Foo::Bar {}'

-e:1: syntax error, unexpected '{'

Foo::Bar {}

#3 - 08/30/2023 08:26 PM - jeremyevans0 (Jeremy Evans)

It looks like this will be fixed by YARP:

$ ruby -r yarp -e "pp YARP.parse('Foo::Bar {}')"

#<YARP::ParseResult:0x00000b1512acc448

 @comments=[],

 @errors=[],

 @source=#<YARP::Source:0x00000b14749d6690 @offsets=[0], @source="Foo::Bar {}">,

 @value=

  ProgramNode(0...11)(
    [],

    StatementsNode(0...11)(

      [CallNode(0...11)(ConstantReadNode(0...3)(), (3...5), (5...8), nil, nil, nil, BlockNode(9...11)([], nil,

 nil, (9...10), (10...11)), 0, "Bar")]

    )

  ),

 @warnings=[]>

#4 - 03/21/2025 04:46 AM - qnighy (Masaki Hara)

Now Foo::Bar {} parses in parse.y too, but Foo::Bar {} + 1 still doesn't parse unlike in Prism.

#5 - 05/07/2025 06:07 AM - mame (Yusuke Endoh)

- Status changed from Open to Assigned

- Assignee set to ydah (Yudai Takada)
